<?php

///////////////////////////////////////////////////////////////////////////////
//                                                                           //
// KorelStar MusicServer                                                     //
// =====================                                                     //
// (c) Copyright 2000-2002 by Kristof Hamann                                 //
//                                                                           //
// Entwickelt von Kristof Hamann                                             //
// Homepage vom MusicServer: http://www.korelstar.de/musicserver/            //
//                                                                           //
// Dieses Programm darf frei genutzt werden. Jegliche Vernderung ist jedoch //
// nur fr eigene Zwecke erlaubt, solange diese Credits unverndert bleiben. //
// Das Verffentlichen des vernderten Programmes ist nicht gestattet,       //
// hingegen ist das Weitergeben dieses Tools, so wie es auf der Homepage vom //
// MusicServer verffentlicht wurde, gestattet.                              //
//                                                                           //
// Da dieses Programm kostenlos ist, kann kein Support gewhrleistet werden. //
// Fr durch dieses Programm entstandene Schden wird nicht gehaftet.        //
//                                                                           //
///////////////////////////////////////////////////////////////////////////////

require_once dirname(__FILE__)."/var.php";
require_once dirname(__FILE__)."/functions.php";

/* Berechne Startzeit*/
$temp = explode(" ",microtime());
$start = $temp[1] + $temp[0];

echo "Beginne mit der Verarbeitung der Dateien...\n";
/* rekursive-funktion zum auslesen von den verzeichnissen */
function read_dir($d) {
	global $t,$gesamt,$MP3DIR;
	$i=0;
	if($t) echo str_repeat("| ",$t);
	echo "Verzeichnis: $d\n";
	if(!is_readable($MP3DIR.$d))
	{
		if($t) echo str_repeat("| ",$t);
		echo "|- Kann nicht gelesen werden.\n";
		return;
	}
	$t++;
	/* verzeichnis auslesen */
	$verz = dir($MP3DIR.$d);
	while($row = $verz->read()) {
		if(substr($row,0,1)!=".") {
			/* verzeichnis? */
			if(is_dir($MP3DIR.$d.($d?"/":"").$row)) read_dir($d.($d?"/":"").$row);
			/* mp3? */
			elseif(strtolower(substr($row,-4))==".mp3") {
				$i++;
				$gesamt++;
				if($t) echo str_repeat("| ",$t);
				echo "MP3 gefunden: $row";
				/* ID3 auslesen und somit auch update in db */
				$mp3info = mp3_getinfo($d.($d?"/":"").$row);
				set_time_limit(10);
				if($mp3info) {
					echo " - ";
					echo $mp3info["song"]." - ".$mp3info["artist"];
				}
				echo "\n";
			}
		}
	}
	$verz->close();
	$t--;
	if($t) echo str_repeat("| ",$t);
	echo "|- $i Songs\n";
}
/* tabelle songs leeren */
mysql_query("DELETE FROM songs");
/* los gehts */
$t=0; $gesamt=0;
read_dir("");
echo "Insgesamt $gesamt Songs verarbeitet.\n";

/* Berechne Dauer und gebe aus */
$temp = explode(" ",microtime());
$ende = $temp[1] + $temp[0];
$script = $ende - $start;

echo "Fertig (".number_format($script,4)." Sekunden)\n";

?>