<?php

///////////////////////////////////////////////////////////////////////////////
//                                                                           //
// KorelStar MusicServer                                                     //
// =====================                                                     //
// (c) Copyright 2000-2002 by Kristof Hamann                                 //
//                                                                           //
// Entwickelt von Kristof Hamann                                             //
// Homepage vom MusicServer: http://www.korelstar.de/musicserver/            //
//                                                                           //
// Dieses Programm darf frei genutzt werden. Jegliche Vernderung ist jedoch //
// nur fr eigene Zwecke erlaubt, solange diese Credits unverndert bleiben. //
// Das Verffentlichen des vernderten Programmes ist nicht gestattet,       //
// hingegen ist das Weitergeben dieses Tools, so wie es auf der Homepage vom //
// MusicServer verffentlicht wurde, gestattet.                              //
//                                                                           //
// Da dieses Programm kostenlos ist, kann kein Support gewhrleistet werden. //
// Fr durch dieses Programm entstandene Schden wird nicht gehaftet.        //
//                                                                           //
///////////////////////////////////////////////////////////////////////////////

// Erstellt M3U-Liste fr SAMBA statt Songs in Server-Playliste hinzuzufgen
function send_m3u($datei)
{
	global $SAMBA;
	// falls $datei kein array ist, eines draus machen
	if(!is_array($datei)) $datei = array($datei);

	// Lokales Abspielen von MP3s (schickt m3u-Playliste an Browser)
	header("Content-Type: audio/x-mpegurl");
	header("Content-disposition: filename=playliste.m3u");
	foreach($datei as $d)
	{
		echo $SAMBA.str_replace("/","\\",$d)."\r\n";
	}
	exit;
}


// komplexe Funktion zum hinzufgen von songs
function song_add($datei,$repeat,$pos,$song="")
{
	global $HELD;
	$n=0;
	// falls $datei kein array ist, eines draus machen
	if(!is_array($datei)) $datei = array($datei);
	// Sicherheitscheck:
	if(!empty($HELD) && get_username()!=$HELD)
	{
		$repeat=0;
		$pos="";
	}

	// array-durchlauf, jeweils hinzufuegen in db
	for($i=0;$i<count($datei);$i++)
	{
		if(!$song || ($song!="NONE" && $song[$i]))
		{
			echo "Hinzuf&uuml;gen der Datei ".$datei[$i]."...";
			// sicherheits-check
			if(strstr($datei[$i],"..")) $datei[$i]="";
			if(substr($datei[$i],0,1)=="/") $datei[$i]="";

			if(strtolower(substr($datei[$i],-4))==".mp3")
			{
				if(is_readable($GLOBALS["MP3DIR"].$datei[$i]))
				{
					mysql_query("INSERT INTO playlist (datei,repeat,user) VALUES ('".addslashes(stripslashes($datei[$i]))."','".($repeat?1:0)."','".addslashes(get_username())."')") or die("\n<br /><b>MySQL-Fehler in Zeile ".__LINE__." (".__FILE__."): ".mysql_error().$GLOBALS["FOOT"]);
					$nr_last = mysql_insert_id();
					if(!$nr_first) $nr_first = $nr_last;
					echo "OK<br />";
					$n++;
				} else echo "<font color=\"#FF0000\">Datei ist nicht lesbar</font><br />";
			} else echo "<font color=\"#FF0000\">Datei ist keine MP3</font><br />";
		}
	}
	// wenn die neuen songs an den anfang sollen, entsprechen herumwurschteln
	if($pos=="anfang" && $nr_first)
	{
		echo "Sortieren der Playliste...";
		$result = mysql_query("SELECT MIN(nr) FROM playlist") or die("\n<br /><b>MySQL-Fehler in Zeile ".__LINE__." (".__FILE__."): ".mysql_error()."</b>".$GLOBALS["FOOT"]);
		$row=mysql_fetch_array($result);
		if($row[0])
		{
			mysql_query("UPDATE playlist SET nr=nr+".($nr_last-$row[0]+1)." WHERE nr<'".$nr_first."'") or die("\n<br /><b>MySQL-Fehler in Zeile ".__LINE__." (".__FILE__."): ".mysql_error().$GLOBALS["FOOT"]);
		}
		echo "OK<br />";
	}
	return $n;
}


// modifiziert den Status des MP3-Players
function mp3_status($status)
{
	global $EXEC;
	if($status=="start")
	{
		echo "Starten des Players..."; flush();
		mysql_query("REPLACE config SET name='status', value='start'");
		echo "Fertig";
		flush();
	}
	elseif($status=="stop")
	{
		echo "Beenden des aktuellen Liedes...";
		flush();
		mysql_query("REPLACE config SET name='status', value='stop'");
		$PID = trim(`ps -C $EXEC -o pid h`);
		if($PID)
		{
			$PID = explode("\n",$PID);
			for($i=0;$i<count($PID);$i++)
			{
				$cur = trim($PID[$i]);
				echo $cur."...";
				flush();
				`kill $cur`;
			}
			echo "Fertig<br />";
		} else echo "Fertig (Kein Prozess gestartet)<br />";
		flush();
	}
	elseif($status=="restart")
	{
		mp3_status("stop");
		sleep(1);
		mp3_status("start");
	}
	else
	{
		echo "Ung&uuml;ltiger Aufruf der Funktion mp3_status.<br />";
	}
}


// advanced back-button-generatro
function back_button($query,$type)
{
	global $PHP_SELF;
	if(!is_array($type)) $type=array($type);
	while(list(,$val)=each($type))
	{
		if($val=="link") echo "<a href=\"$PHP_SELF?$query\">Zur&uuml;ck</a><br />";
		if($val=="meta") echo "<meta http-equiv=\"refresh\" content=\"2; URL=$PHP_SELF?$query\" />";
	}
}



///////////////////////////////////////////////////////////////////////
////// I D 3 //////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////

// liest infos aus MP3
function mp3_getinfo($datei,$update=1,$advanced=0)
{
	global $MP3DIR;
	$mp3info = array();
	$mp3info["size"] = @filesize($MP3DIR.$datei);
	$mp3info["datei"] = $datei;

	// Sicherheitschecks
	if(strtolower(substr($datei,-4))!=".mp3" || strstr($datei,"..") || substr($datei,0,1)=="/" || !is_file($MP3DIR.$datei) || !is_readable($MP3DIR.$datei))
	{
		if($GLOBALS["DEBUG"]) echo "Keine g&uuml;ltige MP3 gew&auml;hlt.<br />";
		return false;
	}

	// auslesen der datei
	$fp = fopen($MP3DIR.$datei,"r");
	if(!$fp)
	{
		if($GLOBALS["DEBUG"]) echo "Konnte Datei nicht oeffnen.<br />";
		return false;
	}

	fseek($fp,0);
	$mp3head_asc = fread($fp,4);
	// ID3v2-Tag
	if(substr($mp3head_asc,0,3)=="ID3")
	{
		// lese restlichen IDv2-header aus
		$mp3v2head_asc = $mp3head_asc . fread($fp,6);
		$mp3v2head = asc2bin($mp3v2head_asc);
		if($GLOBALS["DEBUG"]) echo "<b>IDv2-Header:</b> ".chunk_split($mp3v2head,8," ")."<br />";
		// Laenge des ID3v2-Headers
		$mp3v2headext_len = bindec(substr($mp3v2head,49,7).substr($mp3v2head,57,7).substr($mp3v2head,65,7).substr($mp3v2head,73,7));
		if($GLOBALS["DEBUG"]) echo "Laenge des ID3v2-Headers: $mp3v2headext_len<br />";
		// checke ob Erweiterten Headers ???? !!!! ????
		if($mp3v2head[49])
		{
			if($GLOBALS["DEBUG"]) echo "Erweiterter Header, noch nicht programmiert.<br />";
		}
		// Version, kenne nur die 3.
		$mp3info["id3v2"] = bindec(substr($mp3v2head,24,8));
		if($mp3info["id3v2"]==3)
		{
			// Lese ID3v2-Informationen aus (alle Frames)
			fseek($fp,10);
			$mp3v2data = fread($fp,$mp3v2headext_len);
			$curpos = 0;
			while($curpos < $mp3v2headext_len)
			{
				$mp3v2frameid    = substr($mp3v2data,$curpos + 0,4);
				if(!trim($mp3v2frameid)) break;
				$mp3v2framesize  = bindec(asc2bin(substr($mp3v2data,$curpos + 4,4)));
				$mp3v2frameflags = asc2bin(substr($mp3v2data,$curpos + 8,2));
				$mp3v2framedata  = substr($mp3v2data,$curpos + 10,$mp3v2framesize);
				$curpos += 10 + $mp3v2framesize;
				if($GLOBALS["DEBUG"]) echo "<b>$mp3v2frameid</b> (Len: $mp3v2framesize, Flags: ".chunk_split($mp3v2frameflags,8," ").") = $mp3v2framedata <small>[".chunk_split(asc2bin($mp3v2framedata),8," ")."]</small><br />";
				switch($mp3v2frameid)
				{
					case "TPE1": $mp3info["artist"]  = trim($mp3v2framedata); break;
					case "TIT2": $mp3info["song"]    = trim($mp3v2framedata); break;
					case "TRCK": $mp3info["track"]   = trim($mp3v2framedata); break;
					case "TYER": $mp3info["year"]    = trim($mp3v2framedata); break;
					case "TALB": $mp3info["album"]   = trim($mp3v2framedata); break;
					case "COMM": $mp3info["comment"] = trim(substr($mp3v2framedata,4)); break;
					case "TCON": if(substr($mp3v2framedata,1,1)=="(") $mp3info["genre"] = (int)substr($mp3v2framedata,2,3); break;
				}
			}
		}
		elseif($GLOBALS["DEBUG"]) echo "ID3v2-Tag-Version ist nicht 3. Kenne ich leider nicht.<br />";
		// Lese MP3-Header fuer Advanced-Mod aus
		if($advanced)
		{
			$mp3v2_startdata = $mp3v2headext_len + 10;
			if($GLOBALS["DEBUG"]) echo "MP3 beginnt bei Byte ".$mp3v2_startdata.".<br />";
			fseek($fp,$mp3v2_startdata);
			$mp3head_asc = fread($fp,4);
		}
	}

	// auslesen erweiterter informationen (bitrate, etc.)
	if($advanced)
	{
		$mp3headinfo = array();
		if($GLOBALS["DEBUG"]) echo "<br /><b>Erweiterte Infos zur Datei (DEBUG-Modus):</b><br />";
		$mp3head = asc2bin($mp3head_asc);
		if($GLOBALS["DEBUG"]) echo "<b>1. Frame-Header:</b> ".chunk_split($mp3head,8," ")."<br /><br />";
		// lese techn. infos aus
		$mp3headinfo["mpeg"]      = $mp3head[12];
		$mp3headinfo["layer"]     = substr($mp3head, 13, 2);
		$mp3headinfo["protect"]   = $mp3head[15];
		$mp3headinfo["bitrate"]   = substr($mp3head, 16, 4);
		$mp3headinfo["frequency"] = substr($mp3head, 20, 2);
		$mp3headinfo["padding"]   = $mp3head[22];
		$mp3headinfo["private"]   = $mp3head[23];
		$mp3headinfo["mode"]      = substr($mp3head, 24, 2);
		$mp3headinfo["modeext"]   = substr($mp3head, 26, 2);
		$mp3headinfo["copy"]      = $mp3head[28];
		$mp3headinfo["home"]      = $mp3head[29];
		$mp3headinfo["emphasis"]  = substr($mp3head, 30, 2);
		// wandle infos in mp3info um
		switch($mp3headinfo["layer"])
		{
			case "01" : $mp3info["layer"]=3; break;
			case "10" : $mp3info["layer"]=2; break;
			case "11" : $mp3info["layer"]=1; break;
			default   : $mp3info["layer"]="[fehler]"; break;
		}
		if($mp3headinfo["mpeg"])
		{
			switch($mp3headinfo["frequency"])
			{
				case "00" : $mp3info["frequency"]=44100; break;
				case "01" : $mp3info["frequency"]=48000; break;
				case "10" : $mp3info["frequency"]=32000; break;
				default   : $mp3info["frequency"]=""; break;
			}
		}
		else
		{
			switch($mp3headinfo["frequency"])
			{
				case "00" : $mp3info["frequency"]=22050; break;
				case "01" : $mp3info["frequency"]=24000; break;
				case "10" : $mp3info["frequency"]=16000; break;
				default   : $mp3info["frequency"]=""; break;
			}
		}
		switch($mp3headinfo["mode"])
		{
			case "00" : $mp3info["mode"]="Stereo"; break;
			case "01" : $mp3info["mode"]="Joint Stereo"; break;
			case "10" : $mp3info["mode"]="Dual Channel"; break;
			case "11" : $mp3info["mode"]="Mono"; break;
			default   : $mp3info["mode"]="[fehler]"; break;
		}
		switch($mp3headinfo["emphasis"])
		{
			case "00" : $mp3info["emphasis"]="none"; break;
			case "01" : $mp3info["emphasis"]="50/15ms"; break;
			case "10" : $mp3info["emphasis"]="not set"; break;
			case "11" : $mp3info["emphasis"]="CCITT j.17"; break;
			default   : $mp3info["emphasis"]="[fehler]"; break;
		}
		$mp3info["bitrate"] = $GLOBALS["BITRATE"][$mp3headinfo["mpeg"]][$mp3headinfo["layer"]][$mp3headinfo["bitrate"]];
		if((int)$mp3info["frequency"]) $mp3info["framesize"] = floor((144 * $mp3info["bitrate"] * 1000 / $mp3info["frequency"]) + $mp3headinfo["padding"]);
		if((int)$mp3info["framesize"]) $mp3info["frames"] = floor($mp3info["size"] / $mp3info["framesize"]);
		if((int)$mp3info["bitrate"]) $mp3info["length"] = floor($mp3info["size"] / ($mp3info["bitrate"] * 1000 / 8));
		$mp3info["mpeg"] = $mp3headinfo["mpeg"] ? 1 : 2;
		$mp3info["copyright"] = $mp3headinfo["copy"] ? "yes" : "no";
		$mp3info["private"] = $mp3headinfo["private"] ? "yes" : "no";
		$mp3info["home"] = $mp3headinfo["home"] ? "yes" : "no";

		if($GLOBALS["DEBUG"])
		{
			echo "<pre>\$mp3headinfo: ";
			print_r($mp3headinfo);
			echo "<br />\$mp3info: ";
			print_r($mp3info);
			echo "</pre>";
		}
	}


	// beginn des ID3v1-tags bei 128byte von hinten
	fseek($fp,$mp3info["size"]-128);
	$ID3 = fread($fp,128);
	if(strtoupper(substr($ID3,0,3))=="TAG")
	{
		$mp3info["id3v1"] = 1;
		if($GLOBALS["DEBUG"]) echo "<b>ID3v1-Tag found</b>.<br />";
		$mp3info["id3song"] = strim(substr($ID3,3,30));
		$mp3info["id3artist"] = strim(substr($ID3,33,30));
		$mp3info["id3album"] = strim(substr($ID3,63,30));
		$mp3info["id3year"] = strim(substr($ID3,93,4));
		$mp3info["id3genre"] = ord($ID3[127]);
		// der trick: falls vorletztes comment-char 0 ist,
		// und das letzte ungleich 0, so gibt das letzte die
		// tracknummer an
		if(ord($ID3[125])==0 && ord($ID3[126])!=0)
		{
			$mp3info["id3comment"] = trim(substr($ID3,97,28));
			$mp3info["id3track"] = ord($ID3[126]);
		}
		else
		{
			$mp3info["id3comment"] = trim(substr($ID3,97,30));
		}
		if(empty($mp3info["song"])) $mp3info["song"] = $mp3info["id3song"];
		if(empty($mp3info["artist"])) $mp3info["artist"] = $mp3info["id3artist"];
		if(empty($mp3info["album"])) $mp3info["album"] = $mp3info["id3album"];
		if(empty($mp3info["year"])) $mp3info["year"] = $mp3info["id3year"];
		if(empty($mp3info["genre"])) $mp3info["genre"] = $mp3info["id3genre"];
		if(empty($mp3info["comment"])) $mp3info["comment"] = $mp3info["id3comment"];
		if(empty($mp3info["track"]) && !empty($mp3info["id3track"])) $mp3info["track"] = $mp3info["id3track"];
	}
	fclose($fp);

	// update des eintrages in der db
	if($mp3info && $update)
	{
		$update_query = array();
		$update_query[] = "date='".time()."'";
		for(reset($mp3info);list($key,$val)=each($mp3info);)
		{
			if(substr($key,0,3)!="id3") $update_query[] = "$key='".addslashes($val)."'";
		}
		mysql_query("REPLACE songs SET ".implode(",",$update_query)) or die(mysql_error());
	}
	return $mp3info;
}


// ID3v1-Tag speichern. ///////////////////////////////////////////////////////
function id3v1save($datei,$song,$artist,$album,$year,$comment,$track,$genre)
{
	global $MP3DIR;
	echo "ID3v1-Tag schreiben (<i>".$datei."</i>)...";
	clearstatcache();
	if(!file_exists($MP3DIR.$datei) || !is_readable($MP3DIR.$datei) || !is_writeable($MP3DIR.$datei))
	{
		echo "Datei existiert nicht oder ist nicht lesbar.<br />";
		return false;
	}
	$dateisize = @filesize($MP3DIR.$datei);
	$fp = @fopen($MP3DIR.$datei,"r+");
	if(!$fp)
	{
		echo "Die Datei konnte nicht ge&ouml;ffnet werden.<br />";
		return false;
	}

	// erstelle ID3...
	$ID3 = "TAG";
	$ID3 .= str_short(stripslashes($song),30,chr(0));
	$ID3 .= str_short(stripslashes($artist),30,chr(0));
	$ID3 .= str_short(stripslashes($album),30,chr(0));
	$ID3 .= str_short(stripslashes($year),4,chr(0));
	$ID3 .= str_short(stripslashes($comment),28,chr(0));
	$ID3 .= chr(0);
	$ID3 .= str_short(stripslashes($track?chr($track):""),1,chr(0));
	$ID3 .= str_short(stripslashes(chr($genre)),1,chr(0));
	if(strlen($ID3)==128)
	{
		// checke derzeitigen status:
		fseek($fp,$dateisize-128);
		if(fread($fp,3)=="TAG")
		{ //ID3v1 vorhanden, also berschreiben
			fseek($fp,$dateisize-128);
			fwrite($fp,$ID3);
		}
		else
		{ //ID3v1 nicht vorhandne, also hinzufgen
			fseek($fp,$dateisize);
			fwrite($fp,$ID3);
		}
		echo "Fertig.<br />";
	} else echo "Interner Fehler: ID3-Length=".strlen($ID3)."<br />";
	fclose($fp);
	return true;
}


// ID3v1-Tag entfernen. /////////////////////////////////
function id3v1remove($datei)
{
	global $MP3DIR;
	echo "ID3v1-Tag entfernen (<i>".$datei."</i>)...";
	clearstatcache();
	if(!file_exists($MP3DIR.$datei) || !is_readable($MP3DIR.$datei) || !is_writeable($MP3DIR.$datei))
	{
		echo "Datei existiert nicht oder ist nicht lesbar.<br />";
		return false;
	}

	$dateisize = @filesize($MP3DIR.$datei);
	$fp = @fopen($MP3DIR.$datei,"r+");
	if(!$fp)
	{
		echo "Die Datei konnte nicht ge&ouml;ffnet werden.<br />";
		return false;
	}

	// checke derzeitigen status:
	fseek($fp,$dateisize-128);
	if(fread($fp,3)=="TAG")
	{
		ftruncate($fp, $dateisize - 128);
	}
	echo "Fertig.<br />";
	fclose($fp);
	return true;
}


// ID3v2-Tag speichern. //////////////////////////////////////////////////////
function id3v2save($datei,$song,$artist,$album,$year,$comment,$track,$genre)
{
	global $MP3DIR;
	echo "ID3v2-Tag schreiben (<i>".$datei."</i>)...";
	clearstatcache();
	if(!file_exists($MP3DIR.$datei) || !is_readable($MP3DIR.$datei) || !is_writeable($MP3DIR.$datei))
	{
		echo "Datei existiert nicht oder ist nicht lesbar.<br />";
		return false;
	}
	$dateisize = @filesize($MP3DIR.$datei);
	$ID3_VALUES = array();
	$fp = @fopen($MP3DIR.$datei,"r+");
	if(!$fp)
	{
		echo "Die Datei konnte nicht ge&ouml;ffnet werden.";
		return false;
	}

	// checke derzeitigen status:
	fseek($fp,0);
	$mp3head_asc = fread($fp,10);
	// ID3v2 existiert
	if(substr($mp3head_asc,0,3)=="ID3")
	{
		$mp3v2head = asc2bin($mp3head_asc);
		// Laenge des ID3v2-Headers
		$mp3v2headext_len = bindec(substr($mp3v2head,49,7).substr($mp3v2head,57,7).substr($mp3v2head,65,7).substr($mp3v2head,73,7));
		// Header lesen
		fseek($fp,10);
		$mp3v2data = fread($fp, $mp3v2headext_len);
		for($curpos=0; $curpos < $mp3v2headext_len; $curpos += 10 + $mp3v2framesize)
		{
			$mp3v2frameid    = substr($mp3v2data,$curpos + 0,4);
			if(!trim($mp3v2frameid)) break;
			$mp3v2framesize  = bindec(asc2bin(substr($mp3v2data,$curpos + 4,4)));
			$mp3v2frameflags = asc2bin(substr($mp3v2data,$curpos + 8,2));
			$mp3v2framedata  = substr($mp3v2data,$curpos + 10,$mp3v2framesize);
			// Nur wenn Flag auf Beibehalten gesetzt ist, auch beibehalten
			if($mp3v2frameflags[0]==0)
			{
				$ID3_VALUES[$mp3v2frameid]["size"]  = $mp3v2framesize;
				$ID3_VALUES[$mp3v2frameid]["flags"] = $mp3v2frameflags;
				$ID3_VALUES[$mp3v2frameid]["data"]  = $mp3v2framedata;
			}

		}
		// Rest der Datei lesen
		fseek($fp,10 + $mp3v2headext_len);
		$mp3_data = fread($fp, $dateisize - 10 - $mp3v2headext_len);
	}
	else
	{
		// Rest der Datei lesen
		fseek($fp,0);
		$mp3_data = fread($fp, $dateisize);
	}
	// Neue Eintraege hinzufuegen
	if($song)    $ID3_VALUES["TIT2"]["data"]  = stripslashes($song);
	if($artist)  $ID3_VALUES["TPE1"]["data"]  = stripslashes($artist);
	if($album)   $ID3_VALUES["TALB"]["data"]  = stripslashes($album);
	if($year)    $ID3_VALUES["TYER"]["data"]  = stripslashes($year);
	if($comment) $ID3_VALUES["COMM"]["data"]  = "ger".chr(0).stripslashes($comment);
	if($track)   $ID3_VALUES["TRCK"]["data"]  = $track;
	if($genre)   $ID3_VALUES["TCON"]["data"]  = "(".$genre.")".$GLOBALS["GENRE"][$genre];
	// Header zusammen setzen
	$ID3frames_string = "";
	for(reset($ID3_VALUES); list($frameid,$daten)=each($ID3_VALUES);)
	{
		$daten["data"] = chr(0).$daten["data"];
		if($daten["flags"]=="") $daten["flags"] = chr(0).chr(0);
		else $daten["flags"] = dec2chr(strlen($daten["flags"]),2);
		$daten["size"] = dec2chr(strlen($daten["data"]),4);
		$ID3frames_string .= $frameid . $daten["size"] . $daten["flags"] . $daten["data"];
	}
	$ID3header_string = "ID3".dec2chr(3,1).chr(0).chr(0).dec2chr(strlen($ID3frames_string),4,7);
	if($GLOBALS["DEBUG"]) echo "Neuer ID3v2-Header-String: \n\n$ID3header_string\n\n<br />";
	if($GLOBALS["DEBUG"]) echo "Neuer ID3v2-Frame-String: \n\n$ID3frames_string\n\n<br />";
	// Datei neu schreiben
	fseek($fp,0);
	fwrite($fp, $ID3header_string . $ID3frames_string . $mp3_data);
	ftruncate($fp, ftell($fp));
	echo "Fertig.<br />";
	fclose($fp);
	return true;
}


// ID3v2-Tag entfernen. ////////////////////////////////////////////////////
function id3v2remove($datei)
{
	global $MP3DIR;
	echo "ID3v2-Tag entfernen (<i>".$datei."</i>)...";
	clearstatcache();
	if(!file_exists($MP3DIR.$datei) || !is_readable($MP3DIR.$datei) || !is_writeable($MP3DIR.$datei))
	{
		echo "Datei existiert nicht oder ist nicht lesbar.<br />";
		return false;
	}
	$dateisize = @filesize($MP3DIR.$datei);
	$fp = @fopen($MP3DIR.$datei,"r+");
	if(!$fp)
	{
		echo "Die Datei konnte nicht ge&ouml;ffnet werden.";
		return false;
	}
	// checke derzeitigen status:
	fseek($fp,0);
	$mp3head_asc = fread($fp,10);
	// ID3v2 existiert
	if(substr($mp3head_asc,0,3)=="ID3")
	{
		$mp3v2head = asc2bin($mp3head_asc);
		// Laenge des ID3v2-Headers
		$mp3v2headext_len = bindec(substr($mp3v2head,49,7).substr($mp3v2head,57,7).substr($mp3v2head,65,7).substr($mp3v2head,73,7));
		fseek($fp,10 + $mp3v2headext_len);
		$mp3_newlen = $dateisize - 10 - $mp3v2headext_len;
		$mp3_data = fread($fp, $mp3_newlen);
		fseek($fp,0);
		fwrite($fp, $mp3_data);
		ftruncate($fp, $mp3_newlen);
	}
	echo "Fertig.<br />";
	fclose($fp);
	return true;
}




///////////////////////////////////////////////////////////////////////
////// L A Y O U T - S C H N I P S E L ////////////////////////////////
///////////////////////////////////////////////////////////////////////


// Zeige Speicherplatz an
function showSpeicherplatz($verz)
{
	$result = exec("df -m ".$verz);
	$result = explode(" ",$result);
	$hdd_info=array();
	for($i=0;$i<count($result);$i++)
	{
		if($result[$i]) $hdd_info[] = $result[$i];
	}
	echo "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\">";
	if(function_exists("imagepng"))
	{
		echo "<tr><td colspan=\"2\" valign=\"bottom\" align=\"center\"><img src=\"$PHP_SELF?action=img&amp;free=".$hdd_info[3]."&amp;used=".$hdd_info[2]."\" width=\"121\" height=\"60\" vspace=\"5\" alt=\"Freier Speicherplatz auf dem Server: ".number_format(100*$hdd_info[3]/($hdd_info[3]+$hdd_info[2]))."%\" /></td></tr>";
	}
	echo "<tr><td colspan=\"2\"><b>Speicherplatz</b></td></tr>";
	echo "<tr><td>Gesamt:</td><td align=\"right\">&nbsp;".number_format(($hdd_info[3]+$hdd_info[2])/1024,2,",",".")."&nbsp;GB</td></tr>";
	echo "<tr><td>Belegt:</td><td align=\"right\">&nbsp;".number_format($hdd_info[2]/1024,2,",",".")."&nbsp;GB</td></tr>";
	echo "<tr><td>Frei:</td><td align=\"right\">&nbsp;".number_format($hdd_info[3]/1024,2,",",".")."&nbsp;GB</td></tr>";
	$str = trim(exec("uptime"));
	if(eregi("^([[:digit:]]{1,2}:[[:digit:]]{2}[ap]m) {1,2}up {1,2}(.*), {1,2}([[:digit:]]*) users?, {1,2}load averages?: ([[:digit:]]{1,3}\.[[:digit:]]{2}), ([[:digit:]]{1,3}\.[[:digit:]]{2}), ([[:digit:]]{1,3}\.[[:digit:]]{2})$",$str,$regs))
	{
		echo "<tr><td><b>Uptime:</b></td><td align=\"right\">&nbsp;".$regs[2]."</td></tr>";
	}


	echo "</table>";
}

// Zeigt Lautstaerken-Regelung an
function showVolumeBar()
{
	global $VOLPROG;
	echo "<table border=\"0\" cellspacing=\"0\" cellpadding=\"1\" bgcolor=\"#000000\"><tr><td>";
	echo "<table border=\"0\" cellspacing=\"0\" cellpadding=\"1\" bgcolor=\"#eeeeee\">";
	echo "<tr><td bgcolor=\"#dddddd\"><b>&nbsp;&nbsp;Lautst&auml;rke&nbsp;&nbsp;</b></td></tr>";
	echo "<tr><td align=\"center\" class=\"klein\"><br /><a href=\"$PHP_SELF?action=status&amp;status=volume&amp;volume=25700\" style=\"text-decoration:none\" title=\"100 %\">max</a><br />";
	$volume = trim(exec($VOLPROG));
	echo "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\">";
	for($i=25;$i>=0;$i--)
	{
		$curvol = $i * 1028;
		echo "<tr><td><a href=\"$PHP_SELF?action=status&amp;status=volume&amp;volume=$curvol\" title=\"".($i*4)." %\"><img src=\"volume".($curvol>$volume?"a":"b").".gif\" width=\"6\" height=\"6\" border=\"0\" alt=\"Volume\" /><img src=\"volume".($curvol>$volume?"a":"b").".gif\" width=\"6\" height=\"6\" border=\"0\" alt=\"Volume\" /></a></td></tr>";
	}
	echo "</table>";
	echo "<a href=\"$PHP_SELF?action=status&amp;status=volume&amp;volume=0\" style=\"text-decoration:none\" title=\"0 %\">min</a><br /><br /></td></tr>";
	echo "</table></td></tr></table>";
}



///////////////////////////////////////////////////////////////////////
////// T O O L S //////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////

// macht aus einem ascii-string einen binaeren
function asc2bin($str)
{
	for($i=0;$i<strlen($str);$i++)
	{
		$str_ret .= str_short(decbin(ord($str[$i])),8,"0",1);
	}
	return $str_ret;
}

// macht aus einer Dec-Zahl einen Char-String
function dec2chr($dec, $stellen, $byte=8)
{
	$bin = decbin($dec);
	$bin = explode(" ",chunk_split(str_short($bin,ceil(strlen($bin)/$byte)*$byte,"0",1),$byte," "));
	for($i=0;$i<$stellen;$i++)
	{
		if($stellen - count($bin) >= $i) $str .= chr(0);
		else $str .= chr(bindec($bin[$i - $stellen + count($bin) -1]));
	}
	return $str;
}

// gibt den aktuellen pfad als link aus
function dir_str($d)
{
	global $MP3DIR, $PHP_SELF;
	$dir_str = "";
	for($tmpd=$d; strlen($tmpd)>1; $tmpd=dirname($tmpd))
	{
		$dir_str = "<a href=\"$PHP_SELF?".(is_dir($MP3DIR.$tmpd)?"action=dir&amp;d=".urlencode($tmpd) : "action=view&amp;datei=".urlencode($tmpd))."\">".htmlentities(basename($tmpd)).($d==$tmpd?"":"/")."</a>".$dir_str;
		if(dirname($tmpd)==basename($tmpd)) break;
	}
	$dir_str = "<a href=\"$PHP_SELF?action=dir&amp;d=\">/</a>".$dir_str;
	return $dir_str;
}


// verkrtzt einen string
function short($str,$len=50)
{
	$str = trim($str);
	if(strlen($str)>$len)
	{
		$str = substr($str,0,10)."...".substr($str,-35,35);
	}
	return $str;
}


// zerlegt einen suchstring
function split_suche($suche)
{
	$wortsuche = array();
	$wortsuche[0] = array();
	$wortsuche[1] = array();
	for($i=0;$i<strlen($suche);$i++)
	{
		$char = $suche[$i];
		if($type)
		{
			if(($char==" " && !$str) || ($str && $char=="\"") || ($i==strlen($suche)-1))
			{
				if($i==strlen($suche)-1 && $char!="\"") $tmp .= $char;
				$tmp = trim($tmp);
				if($tmp)
				{
					if($type=="-") $wortsuche[0][] = $tmp;
					else $wortsuche[1][] = $tmp;
				}
				$tmp=""; $type=""; $str=0;
			} elseif($char=="\"") $str = 1;
			else $tmp .= $char;
		}
		else
		{
			$tmp="";
			if($char!=" ")
			if($char=="-") $type="-";
			elseif($char=="+") $type="+";
			else
			{
				$type="+";
				if($char=="\"") $str = 1;
				else $tmp .= $char;
			}
		}
	}
	return $wortsuche;
}


// verkuerzt/verlaengert einen string auf eine bestimmte anzahl von zeichen
function str_short($str,$length,$char=" ",$type=0)
{
	if(strlen($char)!=1) $char = " ";
	if(strlen($str)<$length)
	{
		if($type) $str = str_repeat($char,$length-strlen($str)) . $str;
		else $str .= str_repeat($char,$length-strlen($str));
	}
	if(strlen($str)>$length) $str = substr($str,0,$length);
	return $str;
}


// macht aus sekunden minuten
function sec2min($sec)
{
	$tmp = $sec/60;
	return floor($tmp).":".str_short(floor((($tmp-floor($tmp))*60)),2,"0",1);
}


// liest den computer-namen vom client
function get_username()
{
	$remote = getenv("REMOTE_ADDR");
	$host = gethostbyaddr($remote);
	if($host==$remote) return $host;
	$computer = explode(".",$host);
	return $computer[0];
}


// strim trimmt auch binre 0
function strim($str)
{
	$buf=""; $ret="";
	$str = trim($str);
	for($i=0;$i<strlen($str);$i++)
	{
		if(ord($str[$i])==0)
		{
			if(strlen($ret)!=0)
			{
				$buf .= $str[$i];
			}
		}
		else
		{
			if($buf)
			{
				$ret .= $buf;
				$buf = "";
			}
			$ret .= $str[$i];
		}
	}
	return $ret;
}

?>